# remirepo/fedora spec file for php-doctrine-migrations
#
# Copyright (c) 2019 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#

%global bootstrap    0
%global gh_commit    215438c0eef3e5f9b7da7d09c6b90756071b43e6
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     doctrine
%global gh_project   migrations
# packagist
%global pk_vendor    %{gh_owner}
%global pk_project   %{gh_project}
# Namespace
%global ns_vendor    Doctrine
%global ns_project   Migrations
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{pk_vendor}-%{pk_project}
Version:        1.8.1
Release:        2%{?dist}
Summary:        PHP Doctrine Migrations project

License:        MIT
URL:            https://github.com/%{gh_owner}/%{gh_project}
Source0:        %{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
BuildRequires:  php-fedora-autoloader-devel
%if %{with_tests}
BuildRequires:  php(language) >= 7.1
BuildRequires:  php-reflection
BuildRequires:  php-simplexml
BuildRequires:  php-date
BuildRequires:  php-dom
BuildRequires:  php-json
BuildRequires:  php-libxml
BuildRequires:  php-pcre
BuildRequires:  php-phar
BuildRequires:  php-spl
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
BuildRequires: (php-composer(doctrine/dbal)          >= 2.6   with php-composer(doctrine/dbal)          < 3)
BuildRequires: (php-composer(symfony/console)        >= 3.3   with php-composer(symfony/console)        < 5)
BuildRequires: (php-composer(ocramius/proxy-manager) >= 2.0   with php-composer(ocramius/proxy-manager) < 3)
# From composer.json
#    "require-dev": {
#        "doctrine/orm": "~2.5",
#        "symfony/yaml": "~3.3|^4.0",
#        "phpunit/phpunit": "~7.0",
#        "doctrine/coding-standard": "^1.0",
#        "jdorn/sql-formatter": "~1.1",
#        "mikey179/vfsStream": "^1.6",
#        "squizlabs/php_codesniffer": "^3.0"
BuildRequires: (php-composer(doctrine/orm)           >= 2.5   with php-composer(doctrine/orm)           < 3)
BuildRequires: (php-composer(symfony/yaml)           >= 3.3   with php-composer(symfony/yaml)           < 5)
BuildRequires: (php-composer(jdorn/sql-formatter)    >= 1.1   with php-composer(jdorn/sql-formatter)    < 2)
BuildRequires: (php-composer(mikey179/vfsStream)     >= 1.6   with php-composer(mikey179/vfsStream)     < 2)
# remirepo:14
%else
BuildRequires:  php-composer(doctrine/dbal)          <  3
BuildRequires:  php-composer(doctrine/dbal)          >= 2.6
BuildRequires:  php-symfony3-console                 >= 3.3
BuildRequires:  php-composer(ocramius/proxy-manager) <  3
BuildRequires:  php-composer(ocramius/proxy-manager) >= 2.0
BuildRequires:  php-composer(doctrine/orm)           <  3
BuildRequires:  php-composer(doctrine/orm)           >= 2.5
BuildRequires:  php-symfony3-yaml                    >= 3.3
BuildRequires:  php-composer(jdorn/sql-formatter)    <  2
BuildRequires:  php-composer(jdorn/sql-formatter)    >= 1.1
BuildRequires:  php-composer(mikey179/vfsStream)     <  2
BuildRequires:  php-composer(mikey179/vfsStream)     >= 1.6
%endif
BuildRequires:  phpunit7
%endif

# From composer.json
#    "require": {
#        "php": "^7.1",
#        "doctrine/dbal": "~2.6",
#        "symfony/console": "~3.3|^4.0",
#        "ocramius/proxy-manager": "^1.0|^2.0"
#    "suggest": {
#        "jdorn/sql-formatter": "Allows to generate formatted SQL with the diff command.",
#        "symfony/yaml": "Allows the use of yaml for migration configuration files."

Requires:       php(language) >= 7.1
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
Requires:      (php-composer(doctrine/dbal)          >= 2.6   with php-composer(doctrine/dbal)          < 3)
Requires:      (php-composer(symfony/console)        >= 3.3   with php-composer(symfony/console)        < 5)
Requires:      (php-composer(ocramius/proxy-manager) >= 2.0   with php-composer(ocramius/proxy-manager) < 3)
Recommends:    (php-composer(mikey179/vfsStream)     >= 1.6   with php-composer(mikey179/vfsStream)     < 2)
Recommends:    (php-composer(symfony/yaml)           >= 3.3   with php-composer(symfony/yaml)           < 5)
# remirepo:7
%else
Requires:       php-composer(doctrine/dbal)          <  3
Requires:       php-composer(doctrine/dbal)          >= 2.6
Requires:       php-symfony3-console                 >= 3.3
Requires:       php-composer(ocramius/proxy-manager) <  3
Requires:       php-composer(ocramius/proxy-manager) >= 2.0
%endif
# From phpcompatinfo report for version 1.8.1
Requires:       php-simplexml
Requires:       php-date
Requires:       php-dom
Requires:       php-json
Requires:       php-libxml
Requires:       php-pcre
Requires:       php-spl

# Autoloader
Requires:       php-composer(fedora/autoloader)

Provides:       php-composer(%{pk_vendor}/%{pk_project}) = %{version}


%description
PHP Doctrine Migrations project offer additional functionality on top of the
database abstraction layer (DBAL) for versioning your database schema and
easily deploying changes to it. It is a very easy to use and a powerful tool.

Documentation: https://www.doctrine-project.org/projects/migrations.html

Autoloader: %{_datadir}/php/%{ns_vendor}/DBAL/%{ns_project}/autoload.php


%prep
%setup -q -n %{gh_project}-%{gh_commit}


%build
: Generate a simple autoloader
%{_bindir}/phpab \
    --output lib/%{ns_vendor}/DBAL/%{ns_project}/autoload.php \
    --template fedora \
    lib/%{ns_vendor}
cat << 'EOF' | tee -a lib/%{ns_vendor}/DBAL/%{ns_project}/autoload.php

// Dependencies
\Fedora\Autoloader\Dependencies::required([
    '%{_datadir}/php/%{ns_vendor}/DBAL/autoload.php',
    [
        '%{_datadir}/php/Symfony4/Component/Console/autoload.php',
        '%{_datadir}/php/Symfony3/Component/Console/autoload.php',
    ],
    '%{_datadir}/php/ProxyManager/autoload.php',
]);
\Fedora\Autoloader\Dependencies::optional([
    '%{_datadir}/php/jdorn-sql-formatter/autoload.php',
    [
        '%{_datadir}/php/Symfony4/Component/Yaml/autoload.php',
        '%{_datadir}/php/Symfony3/Component/Yaml/autoload.php',
    ],
]);
EOF


%install
mkdir -p                              %{buildroot}%{_datadir}/php/%{ns_vendor}
cp -pr lib/%{ns_vendor}/%{ns_project} %{buildroot}%{_datadir}/php/%{ns_vendor}/%{ns_project}
cp -pr lib/%{ns_vendor}/DBAL          %{buildroot}%{_datadir}/php/%{ns_vendor}/DBAL


%check
%if %{with_tests}
: Generate autoloader
mkdir vendor
%{_bindir}/phpab \
    --output vendor/autoload.php \
    --template fedora \
    tests

cat << 'EOF' | tee -a vendor/autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{buildroot}%{_datadir}/php/%{ns_vendor}/DBAL/%{ns_project}/autoload.php',
    '%{_datadir}/php/%{ns_vendor}/ORM/autoload.php',
    '%{_datadir}/php/org/bovigo/vfs/autoload.php',
]);
EOF

# need investigation (migrations directory deleted during test suite?)
chmod -w tests/Doctrine/DBAL/Migrations/Tests/Functional/_files

: Run test suite
ret=0
for cmd in php php71 php72 php73; do
  if which $cmd; then
    $cmd %{_bindir}/phpunit7 \
        --bootstrap vendor/autoload.php \
        --verbose || ret=1
  fi
done

# restore
chmod +w tests/Doctrine/DBAL/Migrations/Tests/Functional/_files

exit $ret
%else
: Test suite disabled
%endif


%files
# remirepo:1
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{_datadir}/php/%{ns_vendor}/%{ns_project}/
%{_datadir}/php/%{ns_vendor}/DBAL/%{ns_project}


%changelog
* Thu Jan  3 2019 Remi Collet <remi@remirepo.net> - 1.8.1-2
- move autoloader in Doctrine/DBAL/Migration
  for compatibility with version 1.5.0

* Thu Jan  3 2019 Remi Collet <remi@remirepo.net> - 1.8.1-1
- initial package, version 1.8.1
